﻿//YahooFinance.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Threading;
using System.Threading.Tasks;

public class YahooFinance
{
    static Dictionary<string, double> priceCache = new Dictionary<string, double>();

    public static double GetPrice(string ticker)
    {
        WebClient webClient = new WebClient();
        string data = webClient.DownloadString("http://ichart.finance.yahoo.com/table.csv?s=" + ticker);
        data = data.Split(new char[] { '\n' })[1];
        string[] dataItems = data.Split(new char[] { ',' });
        return Double.Parse(dataItems[dataItems.Length - 1]);
    }

    internal async static Task<double> GetPriceAsync(string ticker)
    {
        if (!priceCache.ContainsKey(ticker))
        {
            double price = await Task<double>.Run(() => YahooFinance.GetPrice(ticker));
            priceCache[ticker] = price;
        }

        return priceCache[ticker];
    }
}
